/* application-window.c generated by valac 0.32.1, the Vala compiler
 * generated from application-window.vala, do not modify */

/*
Peek Copyright (c) 2015-2016 by Philipp Wolfer <ph.wolfer@gmail.com>

This file is part of Peek.

This software is licensed under the GNU General Public License
(version 3 or later). See the LICENSE file in this distribution.

This file contains GPL 3 code taken from corebird, a Gtk+ linux Twitter client.
Copyright (C) 2013 Timm Bäder, https://github.com/baedert/corebird/
*/

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include "application.h"
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <stdio.h>
#include <gdk/gdk.h>
#include <cairo.h>
#include <glib/gi18n-lib.h>
#include <glib/gstdio.h>


#define PEEK_TYPE_APPLICATION_WINDOW (peek_application_window_get_type ())
#define PEEK_APPLICATION_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PEEK_TYPE_APPLICATION_WINDOW, PeekApplicationWindow))
#define PEEK_APPLICATION_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PEEK_TYPE_APPLICATION_WINDOW, PeekApplicationWindowClass))
#define PEEK_IS_APPLICATION_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PEEK_TYPE_APPLICATION_WINDOW))
#define PEEK_IS_APPLICATION_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PEEK_TYPE_APPLICATION_WINDOW))
#define PEEK_APPLICATION_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PEEK_TYPE_APPLICATION_WINDOW, PeekApplicationWindowClass))

typedef struct _PeekApplicationWindow PeekApplicationWindow;
typedef struct _PeekApplicationWindowClass PeekApplicationWindowClass;
typedef struct _PeekApplicationWindowPrivate PeekApplicationWindowPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
typedef struct _Block1Data Block1Data;
#define _cairo_region_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_region_destroy (var), NULL)))
typedef struct _Block2Data Block2Data;
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_variant_builder_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_builder_unref (var), NULL)))

struct _PeekApplicationWindow {
	GtkApplicationWindow parent_instance;
	PeekApplicationWindowPrivate * priv;
};

struct _PeekApplicationWindowClass {
	GtkApplicationWindowClass parent_class;
};

struct _PeekApplicationWindowPrivate {
	PeekRecordingScreenRecorder* _recorder;
	gboolean _open_file_manager;
	gint _size_indicator_delay;
	gint _recording_start_delay;
	gchar* _default_file_name_format;
	gchar* _save_folder;
	GtkWidget* recording_view;
	GtkButton* record_button;
	GtkButton* stop_button;
	GtkLabel* size_indicator;
	GtkLabel* delay_indicator;
	guint size_indicator_timeout;
	guint delay_indicator_timeout;
	gboolean screen_supports_alpha;
	gboolean is_recording;
	GFile* in_file;
	GFile* out_file;
	PeekRecordingRecordingArea active_recording_area;
	GSettings* settings;
};

struct _Block1Data {
	int _ref_count_;
	PeekApplicationWindow* self;
	gint delay;
};

struct _Block2Data {
	int _ref_count_;
	PeekApplicationWindow* self;
	GtkWidget* fallback_app_menu;
};


static gpointer peek_application_window_parent_class = NULL;

GType peek_application_window_get_type (void) G_GNUC_CONST;
#define PEEK_APPLICATION_WINDOW_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), PEEK_TYPE_APPLICATION_WINDOW, PeekApplicationWindowPrivate))
enum  {
	PEEK_APPLICATION_WINDOW_DUMMY_PROPERTY,
	PEEK_APPLICATION_WINDOW_RECORDER,
	PEEK_APPLICATION_WINDOW_OPEN_FILE_MANAGER,
	PEEK_APPLICATION_WINDOW_SIZE_INDICATOR_DELAY,
	PEEK_APPLICATION_WINDOW_RECORDING_START_DELAY,
	PEEK_APPLICATION_WINDOW_DEFAULT_FILE_NAME_FORMAT,
	PEEK_APPLICATION_WINDOW_SAVE_FOLDER
};
PeekApplicationWindow* peek_application_window_new (GtkApplication* application, PeekRecordingScreenRecorder* recorder);
PeekApplicationWindow* peek_application_window_construct (GType object_type, GtkApplication* application, PeekRecordingScreenRecorder* recorder);
void peek_application_window_set_recorder (PeekApplicationWindow* self, PeekRecordingScreenRecorder* value);
PeekRecordingScreenRecorder* peek_application_window_get_recorder (PeekApplicationWindow* self);
static void __lambda7_ (PeekApplicationWindow* self);
static void peek_application_window_enter_recording_state (PeekApplicationWindow* self);
static void ___lambda7__peek_recording_screen_recorder_recording_started (PeekRecordingScreenRecorder* _sender, gpointer self);
static void __lambda8_ (PeekApplicationWindow* self, GFile* file);
static void peek_application_window_try_save_file (PeekApplicationWindow* self);
static void ___lambda8__peek_recording_screen_recorder_recording_finished (PeekRecordingScreenRecorder* _sender, GFile* file, gpointer self);
static void __lambda11_ (PeekApplicationWindow* self, gint status);
static void peek_application_window_leave_recording_state (PeekApplicationWindow* self);
static void ___lambda11__peek_recording_screen_recorder_recording_aborted (PeekRecordingScreenRecorder* _sender, gint status, gpointer self);
static void peek_application_window_load_geometry (PeekApplicationWindow* self);
void peek_application_window_on_window_screen_changed (PeekApplicationWindow* self, GdkScreen* previous_screen);
static gboolean peek_application_window_real_configure_event (GtkWidget* base, GdkEventConfigure* event);
static void peek_application_window_get_recording_area (PeekApplicationWindow* self, PeekRecordingRecordingArea* result);
static gboolean peek_application_window_real_delete_event (GtkWidget* base, GdkEventAny* event);
static void peek_application_window_save_geometry (PeekApplicationWindow* self);
static void _peek_application_window_on_window_screen_changed_gtk_widget_screen_changed (GtkWidget* _sender, GdkScreen* previous_screen, gpointer self);
static gboolean peek_application_window_on_recording_view_draw (PeekApplicationWindow* self, GtkWidget* widget, cairo_t* ctx);
static void peek_application_window_update_input_shape (PeekApplicationWindow* self);
static gboolean _peek_application_window_on_recording_view_draw_gtk_widget_draw (GtkWidget* _sender, cairo_t* cr, gpointer self);
static void peek_application_window_on_recording_view_size_allocate (PeekApplicationWindow* self, GtkAllocation* allocation);
gint peek_application_window_get_size_indicator_delay (PeekApplicationWindow* self);
static gboolean ____lambda13_ (PeekApplicationWindow* self);
static gboolean _____lambda13__gsource_func (gpointer self);
static void _peek_application_window_on_recording_view_size_allocate_gtk_widget_size_allocate (GtkWidget* _sender, GtkAllocation* allocation, gpointer self);
static void peek_application_window_on_record_button_clicked (PeekApplicationWindow* self, GtkButton* source);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
gint peek_application_window_get_recording_start_delay (PeekApplicationWindow* self);
static gboolean ___lambda14_ (Block1Data* _data1_);
static void peek_application_window_start_recording (PeekApplicationWindow* self);
static gboolean ____lambda14__gsource_func (gpointer self);
static void _peek_application_window_on_record_button_clicked_gtk_button_clicked (GtkButton* _sender, gpointer self);
static void peek_application_window_on_stop_button_clicked (PeekApplicationWindow* self, GtkButton* source);
static void peek_application_window_show_file_chooser (PeekApplicationWindow* self);
static void _peek_application_window_on_stop_button_clicked_gtk_button_clicked (GtkButton* _sender, gpointer self);
static void peek_application_window_freeze_window_size (PeekApplicationWindow* self);
static void peek_application_window_unfreeze_window_size (PeekApplicationWindow* self);
static cairo_region_t* peek_application_window_create_region_from_widget (PeekApplicationWindow* self, GtkWidget* widget);
static GtkWidget* peek_application_window_get_fallback_app_menu (PeekApplicationWindow* self);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void __lambda12_ (Block2Data* _data2_, GtkWidget* child);
static void ___lambda12__gtk_callback (GtkWidget* widget, gpointer self);
static gchar* peek_application_window_load_preferred_save_folder (PeekApplicationWindow* self);
const gchar* peek_application_window_get_default_file_name_format (PeekApplicationWindow* self);
static void peek_application_window_save_file (PeekApplicationWindow* self);
static void __lambda9_ (PeekApplicationWindow* self, GObject* obj, GAsyncResult* res);
static void peek_application_window_handle_saved_file (PeekApplicationWindow* self, GFile* file);
static void ___lambda10_ (PeekApplicationWindow* self, GObject* obj, GAsyncResult* res);
static void ____lambda10__gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self);
static void ___lambda9__gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self);
static void peek_application_window_save_preferred_save_folder (PeekApplicationWindow* self, GFile* out_file);
gboolean peek_application_window_get_open_file_manager (PeekApplicationWindow* self);
static void peek_application_window_show_file_saved_notification (PeekApplicationWindow* self, GFile* file);
const gchar* peek_application_window_get_save_folder (PeekApplicationWindow* self);
void peek_application_window_set_save_folder (PeekApplicationWindow* self, const gchar* value);
void peek_application_window_set_open_file_manager (PeekApplicationWindow* self, gboolean value);
void peek_application_window_set_size_indicator_delay (PeekApplicationWindow* self, gint value);
void peek_application_window_set_recording_start_delay (PeekApplicationWindow* self, gint value);
void peek_application_window_set_default_file_name_format (PeekApplicationWindow* self, const gchar* value);
static void peek_application_window_finalize (GObject* obj);
static void _vala_peek_application_window_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_peek_application_window_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


static void __lambda7_ (PeekApplicationWindow* self) {
	peek_application_window_enter_recording_state (self);
}


static void ___lambda7__peek_recording_screen_recorder_recording_started (PeekRecordingScreenRecorder* _sender, gpointer self) {
	__lambda7_ ((PeekApplicationWindow*) self);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void __lambda8_ (PeekApplicationWindow* self, GFile* file) {
	GFile* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	g_return_if_fail (file != NULL);
	_tmp0_ = file;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->in_file);
	self->priv->in_file = _tmp1_;
	peek_application_window_try_save_file (self);
}


static void ___lambda8__peek_recording_screen_recorder_recording_finished (PeekRecordingScreenRecorder* _sender, GFile* file, gpointer self) {
	__lambda8_ ((PeekApplicationWindow*) self, file);
}


static void __lambda11_ (PeekApplicationWindow* self, gint status) {
	FILE* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	_tmp0_ = stderr;
	_tmp1_ = status;
	fprintf (_tmp0_, "Recording stopped unexpectedly with return code %i\n", _tmp1_);
	peek_application_window_leave_recording_state (self);
}


static void ___lambda11__peek_recording_screen_recorder_recording_aborted (PeekRecordingScreenRecorder* _sender, gint status, gpointer self) {
	__lambda11_ ((PeekApplicationWindow*) self, status);
}


PeekApplicationWindow* peek_application_window_construct (GType object_type, GtkApplication* application, PeekRecordingScreenRecorder* recorder) {
	PeekApplicationWindow * self = NULL;
	GtkApplication* _tmp0_ = NULL;
	PeekRecordingScreenRecorder* _tmp1_ = NULL;
	PeekRecordingScreenRecorder* _tmp2_ = NULL;
	PeekRecordingScreenRecorder* _tmp3_ = NULL;
	PeekRecordingScreenRecorder* _tmp4_ = NULL;
	GSettings* _tmp5_ = NULL;
	GSettings* _tmp6_ = NULL;
	GSettings* _tmp7_ = NULL;
	GSettings* _tmp8_ = NULL;
	GSettings* _tmp9_ = NULL;
	GtkSettings* _tmp10_ = NULL;
	GSettings* _tmp11_ = NULL;
	PeekRecordingScreenRecorder* _tmp12_ = NULL;
	GSettings* _tmp13_ = NULL;
	GSettings* _tmp14_ = NULL;
	g_return_val_if_fail (application != NULL, NULL);
	g_return_val_if_fail (recorder != NULL, NULL);
	_tmp0_ = application;
	self = (PeekApplicationWindow*) g_object_new (object_type, "application", _tmp0_, NULL);
	_tmp1_ = recorder;
	peek_application_window_set_recorder (self, _tmp1_);
	_tmp2_ = self->priv->_recorder;
	g_signal_connect_object (_tmp2_, "recording-started", (GCallback) ___lambda7__peek_recording_screen_recorder_recording_started, self, 0);
	_tmp3_ = self->priv->_recorder;
	g_signal_connect_object (_tmp3_, "recording-finished", (GCallback) ___lambda8__peek_recording_screen_recorder_recording_finished, self, 0);
	_tmp4_ = self->priv->_recorder;
	g_signal_connect_object (_tmp4_, "recording-aborted", (GCallback) ___lambda11__peek_recording_screen_recorder_recording_aborted, self, 0);
	_tmp5_ = peek_application_get_app_settings ();
	_g_object_unref0 (self->priv->settings);
	self->priv->settings = _tmp5_;
	_tmp6_ = self->priv->settings;
	g_settings_bind (_tmp6_, "interface-open-file-manager", (GObject*) self, "open_file_manager", G_SETTINGS_BIND_DEFAULT);
	_tmp7_ = self->priv->settings;
	g_settings_bind (_tmp7_, "interface-size-indicator-delay", (GObject*) self, "size_indicator_delay", G_SETTINGS_BIND_DEFAULT);
	_tmp8_ = self->priv->settings;
	g_settings_bind (_tmp8_, "interface-default-file-name-format", (GObject*) self, "default_file_name_format", G_SETTINGS_BIND_DEFAULT);
	_tmp9_ = self->priv->settings;
	_tmp10_ = gtk_widget_get_settings ((GtkWidget*) self);
	g_settings_bind (_tmp9_, "interface-prefer-dark-theme", (GObject*) _tmp10_, "gtk_application_prefer_dark_theme", G_SETTINGS_BIND_DEFAULT);
	_tmp11_ = self->priv->settings;
	_tmp12_ = self->priv->_recorder;
	g_settings_bind (_tmp11_, "recording-framerate", (GObject*) _tmp12_, "framerate", G_SETTINGS_BIND_DEFAULT);
	_tmp13_ = self->priv->settings;
	g_settings_bind (_tmp13_, "recording-start-delay", (GObject*) self, "recording_start_delay", G_SETTINGS_BIND_DEFAULT);
	_tmp14_ = self->priv->settings;
	g_settings_bind (_tmp14_, "persist-save-folder", (GObject*) self, "save_folder", G_SETTINGS_BIND_DEFAULT);
	gtk_window_set_keep_above ((GtkWindow*) self, TRUE);
	peek_application_window_load_geometry (self);
	peek_application_window_on_window_screen_changed (self, NULL);
	return self;
}


PeekApplicationWindow* peek_application_window_new (GtkApplication* application, PeekRecordingScreenRecorder* recorder) {
	return peek_application_window_construct (PEEK_TYPE_APPLICATION_WINDOW, application, recorder);
}


static gboolean peek_application_window_real_configure_event (GtkWidget* base, GdkEventConfigure* event) {
	PeekApplicationWindow * self;
	gboolean result = FALSE;
	PeekRecordingScreenRecorder* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	GdkEventConfigure* _tmp7_ = NULL;
	gboolean _tmp8_ = FALSE;
	self = (PeekApplicationWindow*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = self->priv->_recorder;
	_tmp1_ = peek_recording_screen_recorder_get_is_recording (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		PeekRecordingRecordingArea new_recording_area = {0};
		PeekRecordingRecordingArea _tmp3_ = {0};
		PeekRecordingRecordingArea _tmp4_ = {0};
		gboolean _tmp5_ = FALSE;
		peek_application_window_get_recording_area (self, &_tmp3_);
		new_recording_area = _tmp3_;
		_tmp4_ = self->priv->active_recording_area;
		_tmp5_ = peek_recording_recording_area_equals (&new_recording_area, &_tmp4_);
		if (!_tmp5_) {
			PeekRecordingScreenRecorder* _tmp6_ = NULL;
			_tmp6_ = self->priv->_recorder;
			peek_recording_screen_recorder_cancel (_tmp6_);
		}
	}
	_tmp7_ = event;
	_tmp8_ = GTK_WIDGET_CLASS (peek_application_window_parent_class)->configure_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_application_window_get_type (), GtkApplicationWindow), _tmp7_);
	result = _tmp8_;
	return result;
}


static gboolean peek_application_window_real_delete_event (GtkWidget* base, GdkEventAny* event) {
	PeekApplicationWindow * self;
	gboolean result = FALSE;
	PeekRecordingScreenRecorder* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	guint _tmp4_ = 0U;
	guint _tmp6_ = 0U;
	self = (PeekApplicationWindow*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = self->priv->_recorder;
	_tmp1_ = peek_recording_screen_recorder_get_is_recording (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		PeekRecordingScreenRecorder* _tmp3_ = NULL;
		_tmp3_ = self->priv->_recorder;
		peek_recording_screen_recorder_cancel (_tmp3_);
	}
	_tmp4_ = self->priv->size_indicator_timeout;
	if (_tmp4_ != ((guint) 0)) {
		guint _tmp5_ = 0U;
		_tmp5_ = self->priv->size_indicator_timeout;
		g_source_remove (_tmp5_);
	}
	_tmp6_ = self->priv->delay_indicator_timeout;
	if (_tmp6_ != ((guint) 0)) {
		guint _tmp7_ = 0U;
		_tmp7_ = self->priv->delay_indicator_timeout;
		g_source_remove (_tmp7_);
	}
	peek_application_window_save_geometry (self);
	result = FALSE;
	return result;
}


void peek_application_window_on_window_screen_changed (PeekApplicationWindow* self, GdkScreen* previous_screen) {
	GdkScreen* screen = NULL;
	GdkScreen* _tmp0_ = NULL;
	GdkScreen* _tmp1_ = NULL;
	GdkVisual* visual = NULL;
	GdkScreen* _tmp2_ = NULL;
	GdkVisual* _tmp3_ = NULL;
	GdkVisual* _tmp4_ = NULL;
	GdkVisual* _tmp5_ = NULL;
	GdkVisual* _tmp10_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = gtk_window_get_screen ((GtkWindow*) self);
	_tmp1_ = _g_object_ref0 (_tmp0_);
	screen = _tmp1_;
	_tmp2_ = screen;
	_tmp3_ = gdk_screen_get_rgba_visual (_tmp2_);
	_tmp4_ = _g_object_ref0 (_tmp3_);
	visual = _tmp4_;
	_tmp5_ = visual;
	if (_tmp5_ == NULL) {
		FILE* _tmp6_ = NULL;
		GdkScreen* _tmp7_ = NULL;
		GdkVisual* _tmp8_ = NULL;
		GdkVisual* _tmp9_ = NULL;
		_tmp6_ = stderr;
		fprintf (_tmp6_, "Screen does not support alpha channels!");
		_tmp7_ = screen;
		_tmp8_ = gdk_screen_get_system_visual (_tmp7_);
		_tmp9_ = _g_object_ref0 (_tmp8_);
		_g_object_unref0 (visual);
		visual = _tmp9_;
		self->priv->screen_supports_alpha = FALSE;
	} else {
		self->priv->screen_supports_alpha = TRUE;
	}
	_tmp10_ = visual;
	gtk_widget_set_visual ((GtkWidget*) self, _tmp10_);
	_g_object_unref0 (visual);
	_g_object_unref0 (screen);
}


static void _peek_application_window_on_window_screen_changed_gtk_widget_screen_changed (GtkWidget* _sender, GdkScreen* previous_screen, gpointer self) {
	peek_application_window_on_window_screen_changed ((PeekApplicationWindow*) self, previous_screen);
}


static gboolean peek_application_window_on_recording_view_draw (PeekApplicationWindow* self, GtkWidget* widget, cairo_t* ctx) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	cairo_t* _tmp3_ = NULL;
	cairo_t* _tmp4_ = NULL;
	cairo_t* _tmp5_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (widget != NULL, FALSE);
	g_return_val_if_fail (ctx != NULL, FALSE);
	_tmp0_ = self->priv->screen_supports_alpha;
	if (_tmp0_) {
		cairo_t* _tmp1_ = NULL;
		_tmp1_ = ctx;
		cairo_set_source_rgba (_tmp1_, 0.0, 0.0, 0.0, 0.0);
	} else {
		cairo_t* _tmp2_ = NULL;
		_tmp2_ = ctx;
		cairo_set_source_rgb (_tmp2_, 0.0, 0.0, 0.0);
	}
	_tmp3_ = ctx;
	cairo_set_operator (_tmp3_, CAIRO_OPERATOR_CLEAR);
	_tmp4_ = ctx;
	cairo_paint (_tmp4_);
	_tmp5_ = ctx;
	cairo_fill (_tmp5_);
	peek_application_window_update_input_shape (self);
	result = FALSE;
	return result;
}


static gboolean _peek_application_window_on_recording_view_draw_gtk_widget_draw (GtkWidget* _sender, cairo_t* cr, gpointer self) {
	gboolean result;
	result = peek_application_window_on_recording_view_draw ((PeekApplicationWindow*) self, _sender, cr);
	return result;
}


static gboolean ____lambda13_ (PeekApplicationWindow* self) {
	gboolean result = FALSE;
	GtkLabel* _tmp0_ = NULL;
	self->priv->size_indicator_timeout = (guint) 0;
	_tmp0_ = self->priv->size_indicator;
	gtk_widget_set_opacity ((GtkWidget*) _tmp0_, 0.0);
	result = FALSE;
	return result;
}


static gboolean _____lambda13__gsource_func (gpointer self) {
	gboolean result;
	result = ____lambda13_ ((PeekApplicationWindow*) self);
	return result;
}


static void peek_application_window_on_recording_view_size_allocate (PeekApplicationWindow* self, GtkAllocation* allocation) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (allocation != NULL);
	_tmp1_ = gtk_widget_get_realized ((GtkWidget*) self);
	if (_tmp1_) {
		gboolean _tmp2_ = FALSE;
		_tmp2_ = self->priv->is_recording;
		_tmp0_ = !_tmp2_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GString* size_label = NULL;
		GString* _tmp3_ = NULL;
		PeekRecordingRecordingArea area = {0};
		PeekRecordingRecordingArea _tmp4_ = {0};
		GString* _tmp5_ = NULL;
		PeekRecordingRecordingArea _tmp6_ = {0};
		gint _tmp7_ = 0;
		PeekRecordingRecordingArea _tmp8_ = {0};
		gint _tmp9_ = 0;
		GtkLabel* _tmp10_ = NULL;
		GString* _tmp11_ = NULL;
		const gchar* _tmp12_ = NULL;
		GtkLabel* _tmp13_ = NULL;
		guint _tmp14_ = 0U;
		PeekRecordingScreenRecorder* _tmp16_ = NULL;
		gboolean _tmp17_ = FALSE;
		gboolean _tmp18_ = FALSE;
		_tmp3_ = g_string_new ("");
		size_label = _tmp3_;
		peek_application_window_get_recording_area (self, &_tmp4_);
		area = _tmp4_;
		_tmp5_ = size_label;
		_tmp6_ = area;
		_tmp7_ = _tmp6_.width;
		_tmp8_ = area;
		_tmp9_ = _tmp8_.height;
		g_string_printf (_tmp5_, "%i x %i", _tmp7_, _tmp9_);
		_tmp10_ = self->priv->size_indicator;
		_tmp11_ = size_label;
		_tmp12_ = _tmp11_->str;
		gtk_label_set_text (_tmp10_, _tmp12_);
		_tmp13_ = self->priv->size_indicator;
		gtk_widget_show ((GtkWidget*) _tmp13_);
		_tmp14_ = self->priv->size_indicator_timeout;
		if (_tmp14_ != ((guint) 0)) {
			guint _tmp15_ = 0U;
			_tmp15_ = self->priv->size_indicator_timeout;
			g_source_remove (_tmp15_);
		}
		_tmp16_ = self->priv->_recorder;
		_tmp17_ = peek_recording_screen_recorder_get_is_recording (_tmp16_);
		_tmp18_ = _tmp17_;
		if (!_tmp18_) {
			GtkLabel* _tmp19_ = NULL;
			gint _tmp20_ = 0;
			guint _tmp21_ = 0U;
			_tmp19_ = self->priv->size_indicator;
			gtk_widget_set_opacity ((GtkWidget*) _tmp19_, 1.0);
			_tmp20_ = self->priv->_size_indicator_delay;
			_tmp21_ = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) _tmp20_, _____lambda13__gsource_func, g_object_ref (self), g_object_unref);
			self->priv->size_indicator_timeout = _tmp21_;
		}
		_g_string_free0 (size_label);
	}
}


static void _peek_application_window_on_recording_view_size_allocate_gtk_widget_size_allocate (GtkWidget* _sender, GtkAllocation* allocation, gpointer self) {
	peek_application_window_on_recording_view_size_allocate ((PeekApplicationWindow*) self, allocation);
}


static Block1Data* block1_data_ref (Block1Data* _data1_) {
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}


static void block1_data_unref (void * _userdata_) {
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		PeekApplicationWindow* self;
		self = _data1_->self;
		_g_object_unref0 (self);
		g_slice_free (Block1Data, _data1_);
	}
}


static gboolean ___lambda14_ (Block1Data* _data1_) {
	PeekApplicationWindow* self;
	gboolean result = FALSE;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	self = _data1_->self;
	_tmp0_ = _data1_->delay;
	_data1_->delay = _tmp0_ - 1;
	_tmp1_ = _data1_->delay;
	if (_tmp1_ == 0) {
		GtkLabel* _tmp2_ = NULL;
		self->priv->delay_indicator_timeout = (guint) 0;
		_tmp2_ = self->priv->delay_indicator;
		gtk_widget_hide ((GtkWidget*) _tmp2_);
		peek_application_window_start_recording (self);
		result = FALSE;
		return result;
	} else {
		GtkLabel* _tmp3_ = NULL;
		gint _tmp4_ = 0;
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
		_tmp3_ = self->priv->delay_indicator;
		_tmp4_ = _data1_->delay;
		_tmp5_ = g_strdup_printf ("%i", _tmp4_);
		_tmp6_ = _tmp5_;
		gtk_label_set_text (_tmp3_, _tmp6_);
		_g_free0 (_tmp6_);
		result = TRUE;
		return result;
	}
}


static gboolean ____lambda14__gsource_func (gpointer self) {
	gboolean result;
	result = ___lambda14_ (self);
	return result;
}


static void peek_application_window_on_record_button_clicked (PeekApplicationWindow* self, GtkButton* source) {
	Block1Data* _data1_;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (source != NULL);
	_data1_ = g_slice_new0 (Block1Data);
	_data1_->_ref_count_ = 1;
	_data1_->self = g_object_ref (self);
	peek_application_window_enter_recording_state (self);
	_tmp0_ = self->priv->_recording_start_delay;
	_data1_->delay = _tmp0_;
	_tmp1_ = _data1_->delay;
	if (_tmp1_ > 0) {
		GtkLabel* _tmp2_ = NULL;
		gint _tmp3_ = 0;
		gchar* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		GtkLabel* _tmp6_ = NULL;
		GtkLabel* _tmp7_ = NULL;
		guint _tmp8_ = 0U;
		_tmp2_ = self->priv->delay_indicator;
		_tmp3_ = _data1_->delay;
		_tmp4_ = g_strdup_printf ("%i", _tmp3_);
		_tmp5_ = _tmp4_;
		gtk_label_set_text (_tmp2_, _tmp5_);
		_g_free0 (_tmp5_);
		_tmp6_ = self->priv->delay_indicator;
		gtk_widget_show ((GtkWidget*) _tmp6_);
		_tmp7_ = self->priv->size_indicator;
		gtk_widget_hide ((GtkWidget*) _tmp7_);
		_tmp8_ = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 1000, ____lambda14__gsource_func, block1_data_ref (_data1_), block1_data_unref);
		self->priv->delay_indicator_timeout = _tmp8_;
	} else {
		peek_application_window_start_recording (self);
	}
	block1_data_unref (_data1_);
	_data1_ = NULL;
}


static void _peek_application_window_on_record_button_clicked_gtk_button_clicked (GtkButton* _sender, gpointer self) {
	peek_application_window_on_record_button_clicked ((PeekApplicationWindow*) self, _sender);
}


static void peek_application_window_on_stop_button_clicked (PeekApplicationWindow* self, GtkButton* source) {
	guint _tmp0_ = 0U;
	g_return_if_fail (self != NULL);
	g_return_if_fail (source != NULL);
	_tmp0_ = self->priv->delay_indicator_timeout;
	if (_tmp0_ != ((guint) 0)) {
		guint _tmp1_ = 0U;
		_tmp1_ = self->priv->delay_indicator_timeout;
		g_source_remove (_tmp1_);
		self->priv->delay_indicator_timeout = (guint) 0;
		peek_application_window_leave_recording_state (self);
	} else {
		GtkButton* _tmp2_ = NULL;
		GtkButton* _tmp3_ = NULL;
		const gchar* _tmp4_ = NULL;
		PeekRecordingScreenRecorder* _tmp5_ = NULL;
		_tmp2_ = self->priv->stop_button;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp2_, FALSE);
		_tmp3_ = self->priv->stop_button;
		_tmp4_ = _ ("Rendering…");
		gtk_button_set_label (_tmp3_, _tmp4_);
		_tmp5_ = self->priv->_recorder;
		peek_recording_screen_recorder_stop (_tmp5_);
		peek_application_window_show_file_chooser (self);
	}
}


static void _peek_application_window_on_stop_button_clicked_gtk_button_clicked (GtkButton* _sender, gpointer self) {
	peek_application_window_on_stop_button_clicked ((PeekApplicationWindow*) self, _sender);
}


static void peek_application_window_start_recording (PeekApplicationWindow* self) {
	PeekRecordingRecordingArea area = {0};
	PeekRecordingRecordingArea _tmp0_ = {0};
	PeekRecordingRecordingArea _tmp1_ = {0};
	gint _tmp2_ = 0;
	PeekRecordingRecordingArea _tmp3_ = {0};
	gint _tmp4_ = 0;
	PeekRecordingRecordingArea _tmp5_ = {0};
	gint _tmp6_ = 0;
	PeekRecordingRecordingArea _tmp7_ = {0};
	gint _tmp8_ = 0;
	PeekRecordingRecordingArea _tmp9_ = {0};
	PeekRecordingScreenRecorder* _tmp10_ = NULL;
	PeekRecordingRecordingArea _tmp11_ = {0};
	gboolean _tmp12_ = FALSE;
	g_return_if_fail (self != NULL);
	peek_application_window_get_recording_area (self, &_tmp0_);
	area = _tmp0_;
	_tmp1_ = area;
	_tmp2_ = _tmp1_.left;
	_tmp3_ = area;
	_tmp4_ = _tmp3_.top;
	_tmp5_ = area;
	_tmp6_ = _tmp5_.width;
	_tmp7_ = area;
	_tmp8_ = _tmp7_.height;
	g_debug ("application-window.vala:251: Recording area: %i, %i, %i, %i\n", _tmp2_, _tmp4_, _tmp6_, _tmp8_);
	_tmp9_ = area;
	self->priv->active_recording_area = _tmp9_;
	_tmp10_ = self->priv->_recorder;
	_tmp11_ = area;
	_tmp12_ = peek_recording_screen_recorder_record (_tmp10_, &_tmp11_);
	if (!_tmp12_) {
		peek_application_window_leave_recording_state (self);
	}
}


static void peek_application_window_enter_recording_state (PeekApplicationWindow* self) {
	GtkLabel* _tmp0_ = NULL;
	GtkButton* _tmp1_ = NULL;
	GtkButton* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	GtkButton* _tmp4_ = NULL;
	GtkButton* _tmp5_ = NULL;
	g_return_if_fail (self != NULL);
	self->priv->is_recording = TRUE;
	_tmp0_ = self->priv->size_indicator;
	gtk_widget_set_opacity ((GtkWidget*) _tmp0_, 0.0);
	_tmp1_ = self->priv->record_button;
	gtk_widget_hide ((GtkWidget*) _tmp1_);
	_tmp2_ = self->priv->stop_button;
	_tmp3_ = _ ("_Stop");
	gtk_button_set_label (_tmp2_, _tmp3_);
	_tmp4_ = self->priv->stop_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp4_, TRUE);
	_tmp5_ = self->priv->stop_button;
	gtk_widget_show ((GtkWidget*) _tmp5_);
	peek_application_window_freeze_window_size (self);
	gtk_window_set_keep_above ((GtkWindow*) self, TRUE);
}


static void peek_application_window_leave_recording_state (PeekApplicationWindow* self) {
	GtkLabel* _tmp0_ = NULL;
	GtkButton* _tmp1_ = NULL;
	GtkButton* _tmp2_ = NULL;
	g_return_if_fail (self != NULL);
	_g_object_unref0 (self->priv->in_file);
	self->priv->in_file = NULL;
	_g_object_unref0 (self->priv->out_file);
	self->priv->out_file = NULL;
	_tmp0_ = self->priv->delay_indicator;
	gtk_widget_hide ((GtkWidget*) _tmp0_);
	self->priv->is_recording = FALSE;
	_tmp1_ = self->priv->stop_button;
	gtk_widget_hide ((GtkWidget*) _tmp1_);
	_tmp2_ = self->priv->record_button;
	gtk_widget_show ((GtkWidget*) _tmp2_);
	peek_application_window_unfreeze_window_size (self);
}


static void peek_application_window_update_input_shape (PeekApplicationWindow* self) {
	cairo_region_t* window_region = NULL;
	GtkWidget* _tmp0_ = NULL;
	GtkWidget* _tmp1_ = NULL;
	cairo_region_t* _tmp2_ = NULL;
	cairo_region_t* recording_view_region = NULL;
	GtkWidget* _tmp3_ = NULL;
	cairo_region_t* _tmp4_ = NULL;
	cairo_region_t* _tmp5_ = NULL;
	cairo_region_t* _tmp6_ = NULL;
	GtkWidget* fallback_app_menu = NULL;
	GtkWidget* _tmp7_ = NULL;
	gboolean _tmp8_ = FALSE;
	GtkWidget* _tmp9_ = NULL;
	cairo_region_t* _tmp17_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->recording_view;
	_tmp1_ = gtk_widget_get_toplevel (_tmp0_);
	_tmp2_ = peek_application_window_create_region_from_widget (self, _tmp1_);
	window_region = _tmp2_;
	_tmp3_ = self->priv->recording_view;
	_tmp4_ = peek_application_window_create_region_from_widget (self, _tmp3_);
	recording_view_region = _tmp4_;
	_tmp5_ = window_region;
	_tmp6_ = recording_view_region;
	cairo_region_subtract (_tmp5_, _tmp6_);
	_tmp7_ = peek_application_window_get_fallback_app_menu (self);
	fallback_app_menu = _tmp7_;
	_tmp9_ = fallback_app_menu;
	if (_tmp9_ != NULL) {
		GtkWidget* _tmp10_ = NULL;
		gboolean _tmp11_ = FALSE;
		gboolean _tmp12_ = FALSE;
		_tmp10_ = fallback_app_menu;
		_tmp11_ = gtk_widget_get_visible (_tmp10_);
		_tmp12_ = _tmp11_;
		_tmp8_ = _tmp12_;
	} else {
		_tmp8_ = FALSE;
	}
	if (_tmp8_) {
		cairo_region_t* app_menu_region = NULL;
		GtkWidget* _tmp13_ = NULL;
		cairo_region_t* _tmp14_ = NULL;
		cairo_region_t* _tmp15_ = NULL;
		cairo_region_t* _tmp16_ = NULL;
		_tmp13_ = fallback_app_menu;
		_tmp14_ = peek_application_window_create_region_from_widget (self, _tmp13_);
		app_menu_region = _tmp14_;
		_tmp15_ = window_region;
		_tmp16_ = app_menu_region;
		cairo_region_union (_tmp15_, _tmp16_);
		_cairo_region_destroy0 (app_menu_region);
	}
	_tmp17_ = window_region;
	gtk_widget_input_shape_combine_region ((GtkWidget*) self, _tmp17_);
	_g_object_unref0 (fallback_app_menu);
	_cairo_region_destroy0 (recording_view_region);
	_cairo_region_destroy0 (window_region);
}


static Block2Data* block2_data_ref (Block2Data* _data2_) {
	g_atomic_int_inc (&_data2_->_ref_count_);
	return _data2_;
}


static void block2_data_unref (void * _userdata_) {
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
		PeekApplicationWindow* self;
		self = _data2_->self;
		_g_object_unref0 (_data2_->fallback_app_menu);
		_g_object_unref0 (self);
		g_slice_free (Block2Data, _data2_);
	}
}


static void __lambda12_ (Block2Data* _data2_, GtkWidget* child) {
	PeekApplicationWindow* self;
	GtkWidget* _tmp0_ = NULL;
	self = _data2_->self;
	g_return_if_fail (child != NULL);
	_tmp0_ = child;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, gtk_popover_get_type ())) {
		GtkWidget* _tmp1_ = NULL;
		GtkWidget* _tmp2_ = NULL;
		_tmp1_ = child;
		_tmp2_ = _g_object_ref0 (_tmp1_);
		_g_object_unref0 (_data2_->fallback_app_menu);
		_data2_->fallback_app_menu = _tmp2_;
	}
}


static void ___lambda12__gtk_callback (GtkWidget* widget, gpointer self) {
	__lambda12_ (self, widget);
}


static GtkWidget* peek_application_window_get_fallback_app_menu (PeekApplicationWindow* self) {
	GtkWidget* result = NULL;
	Block2Data* _data2_;
	GtkApplication* _tmp0_ = NULL;
	GtkApplication* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	GtkWidget* _tmp3_ = NULL;
	GtkWidget* _tmp4_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_data2_ = g_slice_new0 (Block2Data);
	_data2_->_ref_count_ = 1;
	_data2_->self = g_object_ref (self);
	_tmp0_ = gtk_window_get_application ((GtkWindow*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = gtk_application_prefers_app_menu (_tmp1_);
	if (_tmp2_) {
		result = NULL;
		block2_data_unref (_data2_);
		_data2_ = NULL;
		return result;
	}
	_data2_->fallback_app_menu = NULL;
	gtk_container_forall ((GtkContainer*) self, ___lambda12__gtk_callback, _data2_);
	_tmp3_ = _data2_->fallback_app_menu;
	_tmp4_ = _g_object_ref0 (_tmp3_);
	result = _tmp4_;
	block2_data_unref (_data2_);
	_data2_ = NULL;
	return result;
}


static void peek_application_window_freeze_window_size (PeekApplicationWindow* self) {
	gint width = 0;
	gint _tmp0_ = 0;
	gint height = 0;
	gint _tmp1_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = gtk_widget_get_allocated_width ((GtkWidget*) self);
	width = _tmp0_;
	_tmp1_ = gtk_widget_get_allocated_height ((GtkWidget*) self);
	height = _tmp1_;
	gtk_widget_set_size_request ((GtkWidget*) self, width, height);
	gtk_window_set_resizable ((GtkWindow*) self, FALSE);
}


static void peek_application_window_unfreeze_window_size (PeekApplicationWindow* self) {
	gint width = 0;
	gint _tmp0_ = 0;
	gint height = 0;
	gint _tmp1_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = gtk_widget_get_allocated_width ((GtkWidget*) self);
	width = _tmp0_;
	_tmp1_ = gtk_widget_get_allocated_height ((GtkWidget*) self);
	height = _tmp1_;
	gtk_widget_set_size_request ((GtkWidget*) self, 0, 0);
	gtk_window_set_default_size ((GtkWindow*) self, width, height);
	gtk_window_set_resizable ((GtkWindow*) self, TRUE);
}


static cairo_region_t* peek_application_window_create_region_from_widget (PeekApplicationWindow* self, GtkWidget* widget) {
	cairo_region_t* result = NULL;
	cairo_rectangle_int_t rectangle = {0};
	GtkWidget* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	GtkWidget* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	cairo_rectangle_int_t _tmp4_ = {0};
	GtkWidget* _tmp5_ = NULL;
	GtkWidget* _tmp6_ = NULL;
	GtkWidget* _tmp7_ = NULL;
	gint _tmp8_ = 0;
	gint _tmp9_ = 0;
	cairo_region_t* region = NULL;
	cairo_rectangle_int_t _tmp10_ = {0};
	cairo_region_t* _tmp11_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (widget != NULL, NULL);
	_tmp0_ = widget;
	_tmp1_ = gtk_widget_get_allocated_width (_tmp0_);
	_tmp2_ = widget;
	_tmp3_ = gtk_widget_get_allocated_height (_tmp2_);
	memset (&_tmp4_, 0, sizeof (cairo_rectangle_int_t));
	_tmp4_.width = _tmp1_;
	_tmp4_.height = _tmp3_;
	rectangle = _tmp4_;
	_tmp5_ = widget;
	_tmp6_ = widget;
	_tmp7_ = gtk_widget_get_toplevel (_tmp6_);
	gtk_widget_translate_coordinates (_tmp5_, _tmp7_, 0, 0, &_tmp8_, &_tmp9_);
	rectangle.x = _tmp8_;
	rectangle.y = _tmp9_;
	_tmp10_ = rectangle;
	_tmp11_ = cairo_region_create_rectangle (&_tmp10_);
	region = _tmp11_;
	result = region;
	return result;
}


static void peek_application_window_get_recording_area (PeekApplicationWindow* self, PeekRecordingRecordingArea* result) {
	GdkWindow* recording_view_window = NULL;
	GtkWidget* _tmp0_ = NULL;
	GdkWindow* _tmp1_ = NULL;
	GdkWindow* _tmp2_ = NULL;
	gint scale_factor = 0;
	gint _tmp3_ = 0;
	PeekRecordingRecordingArea area = {0};
	GtkWidget* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	GtkWidget* _tmp6_ = NULL;
	gint _tmp7_ = 0;
	PeekRecordingRecordingArea _tmp8_ = {0};
	gint _tmp9_ = 0;
	gint _tmp10_ = 0;
	gint relative_left = 0;
	gint relative_top = 0;
	GtkWidget* _tmp11_ = NULL;
	GtkWidget* _tmp12_ = NULL;
	GtkWidget* _tmp13_ = NULL;
	gint _tmp14_ = 0;
	gint _tmp15_ = 0;
	PeekRecordingRecordingArea _tmp16_ = {0};
	gint _tmp17_ = 0;
	PeekRecordingRecordingArea _tmp18_ = {0};
	gint _tmp19_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->recording_view;
	_tmp1_ = gtk_widget_get_window (_tmp0_);
	_tmp2_ = _g_object_ref0 (_tmp1_);
	recording_view_window = _tmp2_;
	_tmp3_ = gdk_window_get_scale_factor (recording_view_window);
	scale_factor = _tmp3_;
	_tmp4_ = self->priv->recording_view;
	_tmp5_ = gtk_widget_get_allocated_width (_tmp4_);
	_tmp6_ = self->priv->recording_view;
	_tmp7_ = gtk_widget_get_allocated_height (_tmp6_);
	memset (&_tmp8_, 0, sizeof (PeekRecordingRecordingArea));
	_tmp8_.width = _tmp5_ * scale_factor;
	_tmp8_.height = _tmp7_ * scale_factor;
	area = _tmp8_;
	gdk_window_get_origin (recording_view_window, &_tmp9_, &_tmp10_);
	area.left = _tmp9_;
	area.top = _tmp10_;
	_tmp11_ = self->priv->recording_view;
	_tmp12_ = self->priv->recording_view;
	_tmp13_ = gtk_widget_get_toplevel (_tmp12_);
	gtk_widget_translate_coordinates (_tmp11_, _tmp13_, 0, 0, &_tmp14_, &_tmp15_);
	relative_left = _tmp14_;
	relative_top = _tmp15_;
	_tmp16_ = area;
	_tmp17_ = _tmp16_.left;
	area.left = (_tmp17_ + relative_left) * scale_factor;
	_tmp18_ = area;
	_tmp19_ = _tmp18_.top;
	area.top = (_tmp19_ + relative_top) * scale_factor;
	*result = area;
	_g_object_unref0 (recording_view_window);
	return;
}


static void peek_application_window_show_file_chooser (PeekApplicationWindow* self) {
	GtkFileChooserDialog* chooser = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	GtkFileChooserDialog* _tmp2_ = NULL;
	GtkWidget* ok_button = NULL;
	GtkFileChooserDialog* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	GtkWidget* _tmp5_ = NULL;
	GtkWidget* _tmp6_ = NULL;
	GtkWidget* _tmp7_ = NULL;
	GtkStyleContext* _tmp8_ = NULL;
	GtkFileFilter* filter = NULL;
	GtkFileFilter* _tmp9_ = NULL;
	GtkFileChooserDialog* _tmp10_ = NULL;
	GtkFileChooserDialog* _tmp11_ = NULL;
	GtkFileFilter* _tmp12_ = NULL;
	GtkFileFilter* _tmp13_ = NULL;
	gchar* folder = NULL;
	gchar* _tmp14_ = NULL;
	GtkFileChooserDialog* _tmp15_ = NULL;
	const gchar* _tmp16_ = NULL;
	GDateTime* now = NULL;
	GDateTime* _tmp17_ = NULL;
	gchar* default_name = NULL;
	GDateTime* _tmp18_ = NULL;
	const gchar* _tmp19_ = NULL;
	gchar* _tmp20_ = NULL;
	GtkFileChooserDialog* _tmp21_ = NULL;
	const gchar* _tmp22_ = NULL;
	GtkFileChooserDialog* _tmp23_ = NULL;
	gint _tmp24_ = 0;
	GtkFileChooserDialog* _tmp27_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = _ ("Save animation");
	_tmp1_ = _ ("_Cancel");
	_tmp2_ = (GtkFileChooserDialog*) gtk_file_chooser_dialog_new (_tmp0_, (GtkWindow*) self, GTK_FILE_CHOOSER_ACTION_SAVE, _tmp1_, GTK_RESPONSE_CANCEL, NULL);
	g_object_ref_sink (_tmp2_);
	chooser = _tmp2_;
	_tmp3_ = chooser;
	_tmp4_ = _ ("_Save");
	_tmp5_ = gtk_dialog_add_button ((GtkDialog*) _tmp3_, _tmp4_, (gint) GTK_RESPONSE_OK);
	_tmp6_ = _g_object_ref0 (_tmp5_);
	ok_button = _tmp6_;
	_tmp7_ = ok_button;
	_tmp8_ = gtk_widget_get_style_context (_tmp7_);
	gtk_style_context_add_class (_tmp8_, "suggested-action");
	_tmp9_ = gtk_file_filter_new ();
	g_object_ref_sink (_tmp9_);
	filter = _tmp9_;
	_tmp10_ = chooser;
	gtk_file_chooser_set_do_overwrite_confirmation ((GtkFileChooser*) _tmp10_, TRUE);
	_tmp11_ = chooser;
	_tmp12_ = filter;
	gtk_file_chooser_set_filter ((GtkFileChooser*) _tmp11_, _tmp12_);
	_tmp13_ = filter;
	gtk_file_filter_add_mime_type (_tmp13_, "image/gif");
	_tmp14_ = peek_application_window_load_preferred_save_folder (self);
	folder = _tmp14_;
	_tmp15_ = chooser;
	_tmp16_ = folder;
	gtk_file_chooser_set_current_folder ((GtkFileChooser*) _tmp15_, _tmp16_);
	_tmp17_ = g_date_time_new_now_local ();
	now = _tmp17_;
	_tmp18_ = now;
	_tmp19_ = self->priv->_default_file_name_format;
	_tmp20_ = g_date_time_format (_tmp18_, _tmp19_);
	default_name = _tmp20_;
	_tmp21_ = chooser;
	_tmp22_ = default_name;
	gtk_file_chooser_set_current_name ((GtkFileChooser*) _tmp21_, _tmp22_);
	_tmp23_ = chooser;
	_tmp24_ = gtk_dialog_run ((GtkDialog*) _tmp23_);
	if (_tmp24_ == ((gint) GTK_RESPONSE_OK)) {
		GtkFileChooserDialog* _tmp25_ = NULL;
		GFile* _tmp26_ = NULL;
		_tmp25_ = chooser;
		_tmp26_ = gtk_file_chooser_get_file ((GtkFileChooser*) _tmp25_);
		_g_object_unref0 (self->priv->out_file);
		self->priv->out_file = _tmp26_;
		peek_application_window_try_save_file (self);
	} else {
		peek_application_window_leave_recording_state (self);
	}
	_tmp27_ = chooser;
	g_signal_emit_by_name ((GtkDialog*) _tmp27_, "close");
	_g_free0 (default_name);
	_g_date_time_unref0 (now);
	_g_free0 (folder);
	_g_object_unref0 (filter);
	_g_object_unref0 (ok_button);
	_g_object_unref0 (chooser);
}


static void peek_application_window_try_save_file (PeekApplicationWindow* self) {
	gboolean _tmp0_ = FALSE;
	GFile* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->in_file;
	if (_tmp1_ == NULL) {
		_tmp0_ = TRUE;
	} else {
		GFile* _tmp2_ = NULL;
		_tmp2_ = self->priv->out_file;
		_tmp0_ = _tmp2_ == NULL;
	}
	if (_tmp0_) {
		return;
	}
	peek_application_window_save_file (self);
}


static gchar* bool_to_string (gboolean self) {
	gchar* result = NULL;
	if (self) {
		gchar* _tmp0_ = NULL;
		_tmp0_ = g_strdup ("true");
		result = _tmp0_;
		return result;
	} else {
		gchar* _tmp1_ = NULL;
		_tmp1_ = g_strdup ("false");
		result = _tmp1_;
		return result;
	}
}


static void ___lambda10_ (PeekApplicationWindow* self, GObject* obj, GAsyncResult* res) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (res != NULL);
	{
		gboolean delete_success = FALSE;
		GFile* _tmp0_ = NULL;
		GAsyncResult* _tmp1_ = NULL;
		gboolean _tmp2_ = FALSE;
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_ = NULL;
		_tmp0_ = self->priv->in_file;
		_tmp1_ = res;
		_tmp2_ = g_file_delete_finish (_tmp0_, _tmp1_, &_inner_error_);
		delete_success = _tmp2_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch3_g_error;
		}
		_tmp3_ = bool_to_string (delete_success);
		_tmp4_ = _tmp3_;
		g_debug ("application-window.vala:423: Temp file deleted: %s\n", _tmp4_);
		_g_free0 (_tmp4_);
	}
	goto __finally3;
	__catch3_g_error:
	{
		GError* e = NULL;
		FILE* _tmp5_ = NULL;
		GError* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp5_ = stderr;
		_tmp6_ = e;
		_tmp7_ = _tmp6_->message;
		fprintf (_tmp5_, "Temp file delete error: %s\n", _tmp7_);
		_g_error_free0 (e);
	}
	__finally3:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void ____lambda10__gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self) {
	___lambda10_ ((PeekApplicationWindow*) self, source_object, res);
	g_object_unref (self);
}


static void __lambda9_ (PeekApplicationWindow* self, GObject* obj, GAsyncResult* res) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (res != NULL);
	{
		gboolean copy_success = FALSE;
		GFile* _tmp0_ = NULL;
		GAsyncResult* _tmp1_ = NULL;
		gboolean _tmp2_ = FALSE;
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_ = NULL;
		GFile* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
		GFile* _tmp13_ = NULL;
		_tmp0_ = self->priv->in_file;
		_tmp1_ = res;
		_tmp2_ = g_file_copy_finish (_tmp0_, _tmp1_, &_inner_error_);
		copy_success = _tmp2_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch2_g_error;
		}
		_tmp3_ = bool_to_string (copy_success);
		_tmp4_ = _tmp3_;
		_tmp5_ = self->priv->out_file;
		_tmp6_ = g_file_get_uri (_tmp5_);
		_tmp7_ = _tmp6_;
		g_debug ("application-window.vala:409: File saved %s: %s\n", _tmp4_, _tmp7_);
		_g_free0 (_tmp7_);
		_g_free0 (_tmp4_);
		if (copy_success) {
			GFile* _tmp8_ = NULL;
			_tmp8_ = self->priv->out_file;
			peek_application_window_handle_saved_file (self, _tmp8_);
		} else {
			if (!copy_success) {
				FILE* _tmp9_ = NULL;
				GFile* _tmp10_ = NULL;
				gchar* _tmp11_ = NULL;
				gchar* _tmp12_ = NULL;
				_tmp9_ = stderr;
				_tmp10_ = self->priv->out_file;
				_tmp11_ = g_file_get_uri (_tmp10_);
				_tmp12_ = _tmp11_;
				fprintf (_tmp9_, "Saving file %s failed.", _tmp12_);
				_g_free0 (_tmp12_);
			}
		}
		_tmp13_ = self->priv->in_file;
		g_file_delete_async (_tmp13_, G_PRIORITY_DEFAULT, NULL, ____lambda10__gasync_ready_callback, g_object_ref (self));
	}
	goto __finally2;
	__catch2_g_error:
	{
		GError* e = NULL;
		FILE* _tmp14_ = NULL;
		GError* _tmp15_ = NULL;
		const gchar* _tmp16_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp14_ = stderr;
		_tmp15_ = e;
		_tmp16_ = _tmp15_->message;
		fprintf (_tmp14_, "File save error: %s\n", _tmp16_);
		_g_error_free0 (e);
	}
	__finally2:
	{
		peek_application_window_leave_recording_state (self);
	}
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void ___lambda9__gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self) {
	__lambda9_ ((PeekApplicationWindow*) self, source_object, res);
	g_object_unref (self);
}


static void peek_application_window_save_file (PeekApplicationWindow* self) {
	GFile* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->in_file;
	_tmp1_ = self->priv->out_file;
	g_file_copy_async (_tmp0_, _tmp1_, G_FILE_COPY_OVERWRITE, G_PRIORITY_DEFAULT, NULL, NULL, NULL, ___lambda9__gasync_ready_callback, g_object_ref (self));
}


static void peek_application_window_handle_saved_file (PeekApplicationWindow* self, GFile* file) {
	GFile* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (file != NULL);
	_tmp0_ = file;
	peek_application_window_save_preferred_save_folder (self, _tmp0_);
	_tmp1_ = self->priv->_open_file_manager;
	if (_tmp1_) {
		GFile* _tmp2_ = NULL;
		_tmp2_ = file;
		peek_desktop_integration_launch_file_manager (_tmp2_);
	} else {
		GFile* _tmp3_ = NULL;
		_tmp3_ = file;
		peek_application_window_show_file_saved_notification (self, _tmp3_);
	}
}


static void peek_application_window_show_file_saved_notification (PeekApplicationWindow* self, GFile* file) {
	GString* message = NULL;
	GString* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	GFile* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	GVariant* parameter = NULL;
	GFile* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	GVariant* _tmp8_ = NULL;
	GVariant* _tmp9_ = NULL;
	GNotification* notification = NULL;
	const gchar* _tmp10_ = NULL;
	GNotification* _tmp11_ = NULL;
	const gchar* _tmp12_ = NULL;
	const gchar* _tmp13_ = NULL;
	GtkApplication* _tmp14_ = NULL;
	GtkApplication* _tmp15_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (file != NULL);
	_tmp0_ = g_string_new ("");
	message = _tmp0_;
	_tmp1_ = _ ("Animation saved as “%s”");
	_tmp2_ = file;
	_tmp3_ = g_file_get_basename (_tmp2_);
	_tmp4_ = _tmp3_;
	g_string_printf (message, _tmp1_, _tmp4_);
	_g_free0 (_tmp4_);
	_tmp5_ = file;
	_tmp6_ = g_file_get_uri (_tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = g_variant_new_string (_tmp7_);
	g_variant_ref_sink (_tmp8_);
	_tmp9_ = _tmp8_;
	_g_free0 (_tmp7_);
	parameter = _tmp9_;
	_tmp10_ = message->str;
	_tmp11_ = g_notification_new (_tmp10_);
	notification = _tmp11_;
	_tmp12_ = _ ("Click here to show the saved file in your file manager.");
	g_notification_set_body (notification, _tmp12_);
	_tmp13_ = _ ("Show in file manager");
	g_notification_add_button_with_target_value (notification, _tmp13_, "app.show-file", parameter);
	g_notification_set_default_action_and_target_value (notification, "app.show-file", parameter);
	_tmp14_ = gtk_window_get_application ((GtkWindow*) self);
	_tmp15_ = _tmp14_;
	g_application_send_notification ((GApplication*) _tmp15_, NULL, notification);
	_g_object_unref0 (notification);
	_g_variant_unref0 (parameter);
	_g_string_free0 (message);
}


static gchar* peek_application_window_load_preferred_save_folder (PeekApplicationWindow* self) {
	gchar* result = NULL;
	gchar* folder = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_save_folder;
	_tmp1_ = g_strdup (_tmp0_);
	folder = _tmp1_;
	_tmp4_ = folder;
	if (_tmp4_ == NULL) {
		_tmp3_ = TRUE;
	} else {
		const gchar* _tmp5_ = NULL;
		_tmp5_ = folder;
		_tmp3_ = g_strcmp0 (_tmp5_, "") == 0;
	}
	if (_tmp3_) {
		_tmp2_ = TRUE;
	} else {
		const gchar* _tmp6_ = NULL;
		gboolean _tmp7_ = FALSE;
		_tmp6_ = folder;
		_tmp7_ = g_file_test (_tmp6_, G_FILE_TEST_IS_DIR);
		_tmp2_ = !_tmp7_;
	}
	if (_tmp2_) {
		gchar* _tmp8_ = NULL;
		_tmp8_ = peek_desktop_integration_get_video_folder ();
		_g_free0 (folder);
		folder = _tmp8_;
	}
	result = folder;
	return result;
}


static void peek_application_window_save_preferred_save_folder (PeekApplicationWindow* self, GFile* out_file) {
	GFile* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (out_file != NULL);
	_tmp0_ = out_file;
	_tmp1_ = g_file_has_uri_scheme (_tmp0_, "file");
	if (_tmp1_) {
		GFile* parent = NULL;
		GFile* _tmp2_ = NULL;
		GFile* _tmp3_ = NULL;
		gchar* new_folder = NULL;
		GFile* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		gchar* default_folder = NULL;
		gchar* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		const gchar* _tmp8_ = NULL;
		_tmp2_ = out_file;
		_tmp3_ = g_file_get_parent (_tmp2_);
		parent = _tmp3_;
		_tmp4_ = parent;
		_tmp5_ = g_file_get_path (_tmp4_);
		new_folder = _tmp5_;
		_tmp6_ = peek_desktop_integration_get_video_folder ();
		default_folder = _tmp6_;
		_tmp7_ = new_folder;
		_tmp8_ = default_folder;
		if (g_strcmp0 (_tmp7_, _tmp8_) != 0) {
			const gchar* _tmp9_ = NULL;
			_tmp9_ = new_folder;
			peek_application_window_set_save_folder (self, _tmp9_);
		}
		_g_free0 (default_folder);
		_g_free0 (new_folder);
		_g_object_unref0 (parent);
	}
}


static void peek_application_window_load_geometry (PeekApplicationWindow* self) {
	GVariant* geom = NULL;
	GSettings* _tmp0_ = NULL;
	GVariant* _tmp1_ = NULL;
	gint x = 0;
	gint y = 0;
	gint w = 0;
	gint h = 0;
	GVariant* _tmp2_ = NULL;
	GVariant* _tmp3_ = NULL;
	GVariant* _tmp4_ = NULL;
	gint32 _tmp5_ = 0;
	GVariant* _tmp6_ = NULL;
	GVariant* _tmp7_ = NULL;
	GVariant* _tmp8_ = NULL;
	gint32 _tmp9_ = 0;
	GVariant* _tmp10_ = NULL;
	GVariant* _tmp11_ = NULL;
	GVariant* _tmp12_ = NULL;
	gint32 _tmp13_ = 0;
	GVariant* _tmp14_ = NULL;
	GVariant* _tmp15_ = NULL;
	GVariant* _tmp16_ = NULL;
	gint32 _tmp17_ = 0;
	gboolean _tmp18_ = FALSE;
	gint _tmp19_ = 0;
	gboolean _tmp21_ = FALSE;
	gint _tmp22_ = 0;
	gint _tmp26_ = 0;
	gint _tmp27_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->settings;
	_tmp1_ = g_settings_get_value (_tmp0_, "persist-window-geometry");
	geom = _tmp1_;
	x = 0;
	y = 0;
	w = 0;
	h = 0;
	_tmp2_ = geom;
	_tmp3_ = g_variant_get_child_value (_tmp2_, (gsize) 0);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_variant_get_int32 (_tmp4_);
	x = (gint) _tmp5_;
	_g_variant_unref0 (_tmp4_);
	_tmp6_ = geom;
	_tmp7_ = g_variant_get_child_value (_tmp6_, (gsize) 1);
	_tmp8_ = _tmp7_;
	_tmp9_ = g_variant_get_int32 (_tmp8_);
	y = (gint) _tmp9_;
	_g_variant_unref0 (_tmp8_);
	_tmp10_ = geom;
	_tmp11_ = g_variant_get_child_value (_tmp10_, (gsize) 2);
	_tmp12_ = _tmp11_;
	_tmp13_ = g_variant_get_int32 (_tmp12_);
	w = (gint) _tmp13_;
	_g_variant_unref0 (_tmp12_);
	_tmp14_ = geom;
	_tmp15_ = g_variant_get_child_value (_tmp14_, (gsize) 3);
	_tmp16_ = _tmp15_;
	_tmp17_ = g_variant_get_int32 (_tmp16_);
	h = (gint) _tmp17_;
	_g_variant_unref0 (_tmp16_);
	_tmp19_ = w;
	if (_tmp19_ == 0) {
		_tmp18_ = TRUE;
	} else {
		gint _tmp20_ = 0;
		_tmp20_ = h;
		_tmp18_ = _tmp20_ == 0;
	}
	if (_tmp18_) {
		_g_variant_unref0 (geom);
		return;
	}
	_tmp22_ = x;
	if (_tmp22_ >= 0) {
		gint _tmp23_ = 0;
		_tmp23_ = y;
		_tmp21_ = _tmp23_ >= 0;
	} else {
		_tmp21_ = FALSE;
	}
	if (_tmp21_) {
		gint _tmp24_ = 0;
		gint _tmp25_ = 0;
		_tmp24_ = x;
		_tmp25_ = y;
		gtk_window_move ((GtkWindow*) self, _tmp24_, _tmp25_);
	}
	_tmp26_ = w;
	_tmp27_ = h;
	gtk_window_resize ((GtkWindow*) self, _tmp26_, _tmp27_);
	_g_variant_unref0 (geom);
}


static void peek_application_window_save_geometry (PeekApplicationWindow* self) {
	GVariantBuilder* builder = NULL;
	const GVariantType* _tmp0_ = NULL;
	GVariantBuilder* _tmp1_ = NULL;
	gint x = 0;
	gint y = 0;
	gint w = 0;
	gint h = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	GVariant* _tmp7_ = NULL;
	GVariant* _tmp8_ = NULL;
	gint _tmp9_ = 0;
	GVariant* _tmp10_ = NULL;
	GVariant* _tmp11_ = NULL;
	gint _tmp12_ = 0;
	GVariant* _tmp13_ = NULL;
	GVariant* _tmp14_ = NULL;
	gint _tmp15_ = 0;
	GVariant* _tmp16_ = NULL;
	GVariant* _tmp17_ = NULL;
	GSettings* _tmp18_ = NULL;
	GVariant* _tmp19_ = NULL;
	GVariant* _tmp20_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = G_VARIANT_TYPE_TUPLE;
	_tmp1_ = g_variant_builder_new (_tmp0_);
	builder = _tmp1_;
	x = 0;
	y = 0;
	w = 0;
	h = 0;
	gtk_window_get_position ((GtkWindow*) self, &_tmp2_, &_tmp3_);
	x = _tmp2_;
	y = _tmp3_;
	gtk_window_get_size ((GtkWindow*) self, &_tmp4_, &_tmp5_);
	w = _tmp4_;
	h = _tmp5_;
	_tmp6_ = x;
	_tmp7_ = g_variant_new_int32 ((gint32) _tmp6_);
	g_variant_ref_sink (_tmp7_);
	_tmp8_ = _tmp7_;
	g_variant_builder_add_value (builder, _tmp8_);
	_g_variant_unref0 (_tmp8_);
	_tmp9_ = y;
	_tmp10_ = g_variant_new_int32 ((gint32) _tmp9_);
	g_variant_ref_sink (_tmp10_);
	_tmp11_ = _tmp10_;
	g_variant_builder_add_value (builder, _tmp11_);
	_g_variant_unref0 (_tmp11_);
	_tmp12_ = w;
	_tmp13_ = g_variant_new_int32 ((gint32) _tmp12_);
	g_variant_ref_sink (_tmp13_);
	_tmp14_ = _tmp13_;
	g_variant_builder_add_value (builder, _tmp14_);
	_g_variant_unref0 (_tmp14_);
	_tmp15_ = h;
	_tmp16_ = g_variant_new_int32 ((gint32) _tmp15_);
	g_variant_ref_sink (_tmp16_);
	_tmp17_ = _tmp16_;
	g_variant_builder_add_value (builder, _tmp17_);
	_g_variant_unref0 (_tmp17_);
	_tmp18_ = self->priv->settings;
	_tmp19_ = g_variant_builder_end (builder);
	g_variant_ref_sink (_tmp19_);
	_tmp20_ = _tmp19_;
	g_settings_set_value (_tmp18_, "persist-window-geometry", _tmp20_);
	_g_variant_unref0 (_tmp20_);
	_g_variant_builder_unref0 (builder);
}


PeekRecordingScreenRecorder* peek_application_window_get_recorder (PeekApplicationWindow* self) {
	PeekRecordingScreenRecorder* result;
	PeekRecordingScreenRecorder* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_recorder;
	result = _tmp0_;
	return result;
}


void peek_application_window_set_recorder (PeekApplicationWindow* self, PeekRecordingScreenRecorder* value) {
	PeekRecordingScreenRecorder* _tmp0_ = NULL;
	PeekRecordingScreenRecorder* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_recorder);
	self->priv->_recorder = _tmp1_;
	g_object_notify ((GObject *) self, "recorder");
}


gboolean peek_application_window_get_open_file_manager (PeekApplicationWindow* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_open_file_manager;
	result = _tmp0_;
	return result;
}


void peek_application_window_set_open_file_manager (PeekApplicationWindow* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_open_file_manager = _tmp0_;
	g_object_notify ((GObject *) self, "open-file-manager");
}


gint peek_application_window_get_size_indicator_delay (PeekApplicationWindow* self) {
	gint result;
	gint _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_size_indicator_delay;
	result = _tmp0_;
	return result;
}


void peek_application_window_set_size_indicator_delay (PeekApplicationWindow* self, gint value) {
	gint _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_size_indicator_delay = _tmp0_;
	g_object_notify ((GObject *) self, "size-indicator-delay");
}


gint peek_application_window_get_recording_start_delay (PeekApplicationWindow* self) {
	gint result;
	gint _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_recording_start_delay;
	result = _tmp0_;
	return result;
}


void peek_application_window_set_recording_start_delay (PeekApplicationWindow* self, gint value) {
	gint _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_recording_start_delay = _tmp0_;
	g_object_notify ((GObject *) self, "recording-start-delay");
}


const gchar* peek_application_window_get_default_file_name_format (PeekApplicationWindow* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_default_file_name_format;
	result = _tmp0_;
	return result;
}


void peek_application_window_set_default_file_name_format (PeekApplicationWindow* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_default_file_name_format);
	self->priv->_default_file_name_format = _tmp1_;
	g_object_notify ((GObject *) self, "default-file-name-format");
}


const gchar* peek_application_window_get_save_folder (PeekApplicationWindow* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_save_folder;
	result = _tmp0_;
	return result;
}


void peek_application_window_set_save_folder (PeekApplicationWindow* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_save_folder);
	self->priv->_save_folder = _tmp1_;
	g_object_notify ((GObject *) self, "save-folder");
}


static void peek_application_window_class_init (PeekApplicationWindowClass * klass) {
	gint PeekApplicationWindow_private_offset;
	peek_application_window_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (PeekApplicationWindowPrivate));
	((GtkWidgetClass *) klass)->configure_event = peek_application_window_real_configure_event;
	((GtkWidgetClass *) klass)->delete_event = peek_application_window_real_delete_event;
	G_OBJECT_CLASS (klass)->get_property = _vala_peek_application_window_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_peek_application_window_set_property;
	G_OBJECT_CLASS (klass)->finalize = peek_application_window_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), PEEK_APPLICATION_WINDOW_RECORDER, g_param_spec_object ("recorder", "recorder", "recorder", PEEK_RECORDING_TYPE_SCREEN_RECORDER, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PEEK_APPLICATION_WINDOW_OPEN_FILE_MANAGER, g_param_spec_boolean ("open-file-manager", "open-file-manager", "open-file-manager", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PEEK_APPLICATION_WINDOW_SIZE_INDICATOR_DELAY, g_param_spec_int ("size-indicator-delay", "size-indicator-delay", "size-indicator-delay", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PEEK_APPLICATION_WINDOW_RECORDING_START_DELAY, g_param_spec_int ("recording-start-delay", "recording-start-delay", "recording-start-delay", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PEEK_APPLICATION_WINDOW_DEFAULT_FILE_NAME_FORMAT, g_param_spec_string ("default-file-name-format", "default-file-name-format", "default-file-name-format", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PEEK_APPLICATION_WINDOW_SAVE_FOLDER, g_param_spec_string ("save-folder", "save-folder", "save-folder", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	PeekApplicationWindow_private_offset = g_type_class_get_instance_private_offset (klass);
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/com/uploadedlobster/peek/application-window.ui");
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "recording_view", FALSE, PeekApplicationWindow_private_offset + G_STRUCT_OFFSET (PeekApplicationWindowPrivate, recording_view));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "record_button", FALSE, PeekApplicationWindow_private_offset + G_STRUCT_OFFSET (PeekApplicationWindowPrivate, record_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "stop_button", FALSE, PeekApplicationWindow_private_offset + G_STRUCT_OFFSET (PeekApplicationWindowPrivate, stop_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "size_indicator", FALSE, PeekApplicationWindow_private_offset + G_STRUCT_OFFSET (PeekApplicationWindowPrivate, size_indicator));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "delay_indicator", FALSE, PeekApplicationWindow_private_offset + G_STRUCT_OFFSET (PeekApplicationWindowPrivate, delay_indicator));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_window_screen_changed", G_CALLBACK(_peek_application_window_on_window_screen_changed_gtk_widget_screen_changed));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_recording_view_draw", G_CALLBACK(_peek_application_window_on_recording_view_draw_gtk_widget_draw));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_recording_view_size_allocate", G_CALLBACK(_peek_application_window_on_recording_view_size_allocate_gtk_widget_size_allocate));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_record_button_clicked", G_CALLBACK(_peek_application_window_on_record_button_clicked_gtk_button_clicked));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_stop_button_clicked", G_CALLBACK(_peek_application_window_on_stop_button_clicked_gtk_button_clicked));
}


static void peek_application_window_instance_init (PeekApplicationWindow * self) {
	self->priv = PEEK_APPLICATION_WINDOW_GET_PRIVATE (self);
	self->priv->size_indicator_timeout = (guint) 0;
	self->priv->delay_indicator_timeout = (guint) 0;
	self->priv->screen_supports_alpha = TRUE;
	self->priv->is_recording = FALSE;
	gtk_widget_init_template (GTK_WIDGET (self));
}


static void peek_application_window_finalize (GObject* obj) {
	PeekApplicationWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PEEK_TYPE_APPLICATION_WINDOW, PeekApplicationWindow);
	_g_object_unref0 (self->priv->_recorder);
	_g_free0 (self->priv->_default_file_name_format);
	_g_free0 (self->priv->_save_folder);
	_g_object_unref0 (self->priv->recording_view);
	_g_object_unref0 (self->priv->record_button);
	_g_object_unref0 (self->priv->stop_button);
	_g_object_unref0 (self->priv->size_indicator);
	_g_object_unref0 (self->priv->delay_indicator);
	_g_object_unref0 (self->priv->in_file);
	_g_object_unref0 (self->priv->out_file);
	_g_object_unref0 (self->priv->settings);
	G_OBJECT_CLASS (peek_application_window_parent_class)->finalize (obj);
}


GType peek_application_window_get_type (void) {
	static volatile gsize peek_application_window_type_id__volatile = 0;
	if (g_once_init_enter (&peek_application_window_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PeekApplicationWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) peek_application_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PeekApplicationWindow), 0, (GInstanceInitFunc) peek_application_window_instance_init, NULL };
		GType peek_application_window_type_id;
		peek_application_window_type_id = g_type_register_static (gtk_application_window_get_type (), "PeekApplicationWindow", &g_define_type_info, 0);
		g_once_init_leave (&peek_application_window_type_id__volatile, peek_application_window_type_id);
	}
	return peek_application_window_type_id__volatile;
}


static void _vala_peek_application_window_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	PeekApplicationWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PEEK_TYPE_APPLICATION_WINDOW, PeekApplicationWindow);
	switch (property_id) {
		case PEEK_APPLICATION_WINDOW_RECORDER:
		g_value_set_object (value, peek_application_window_get_recorder (self));
		break;
		case PEEK_APPLICATION_WINDOW_OPEN_FILE_MANAGER:
		g_value_set_boolean (value, peek_application_window_get_open_file_manager (self));
		break;
		case PEEK_APPLICATION_WINDOW_SIZE_INDICATOR_DELAY:
		g_value_set_int (value, peek_application_window_get_size_indicator_delay (self));
		break;
		case PEEK_APPLICATION_WINDOW_RECORDING_START_DELAY:
		g_value_set_int (value, peek_application_window_get_recording_start_delay (self));
		break;
		case PEEK_APPLICATION_WINDOW_DEFAULT_FILE_NAME_FORMAT:
		g_value_set_string (value, peek_application_window_get_default_file_name_format (self));
		break;
		case PEEK_APPLICATION_WINDOW_SAVE_FOLDER:
		g_value_set_string (value, peek_application_window_get_save_folder (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_peek_application_window_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	PeekApplicationWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PEEK_TYPE_APPLICATION_WINDOW, PeekApplicationWindow);
	switch (property_id) {
		case PEEK_APPLICATION_WINDOW_RECORDER:
		peek_application_window_set_recorder (self, g_value_get_object (value));
		break;
		case PEEK_APPLICATION_WINDOW_OPEN_FILE_MANAGER:
		peek_application_window_set_open_file_manager (self, g_value_get_boolean (value));
		break;
		case PEEK_APPLICATION_WINDOW_SIZE_INDICATOR_DELAY:
		peek_application_window_set_size_indicator_delay (self, g_value_get_int (value));
		break;
		case PEEK_APPLICATION_WINDOW_RECORDING_START_DELAY:
		peek_application_window_set_recording_start_delay (self, g_value_get_int (value));
		break;
		case PEEK_APPLICATION_WINDOW_DEFAULT_FILE_NAME_FORMAT:
		peek_application_window_set_default_file_name_format (self, g_value_get_string (value));
		break;
		case PEEK_APPLICATION_WINDOW_SAVE_FOLDER:
		peek_application_window_set_save_folder (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



